﻿using System;
using System.Reflection;
using Microsoft.Xna.Framework;
using PluginLoader;
using Terraria;
using Keys = Microsoft.Xna.Framework.Input.Keys;

namespace TranscendPlugins
{
    public class NPC : MarshalByRefObject, IPluginPlayerUpdate
    {
        private bool fresh = true;
        private int previousMaxSpawns;
        private int previousSpawnRate;

        private FieldInfo defaultMaxSpawns;
        private int DefaultMaxSpawns
        {
            get { return (int)defaultMaxSpawns.GetValue(null); }
            set { defaultMaxSpawns.SetValue(null, value); }
        }

        private FieldInfo defaultSpawnRate;
        private int DefaultSpawnRate
        {
            get { return (int)defaultSpawnRate.GetValue(null); }
            set { defaultSpawnRate.SetValue(null, value); }
        }
        
        public NPC()
        {
            var npc = Assembly.GetEntryAssembly().GetType("Terraria.NPC");
            defaultMaxSpawns = npc.GetField("defaultMaxSpawns", BindingFlags.Static | BindingFlags.NonPublic);
            defaultSpawnRate = npc.GetField("defaultSpawnRate", BindingFlags.Static | BindingFlags.NonPublic);
        }

        public void OnPlayerUpdate()
        {
            if (Main.keyState.IsKeyDown(Keys.N) && fresh)
            {
                fresh = false;

                Color purple = Color.Purple;
                if (DefaultMaxSpawns > 0)
                {
                    previousMaxSpawns = DefaultMaxSpawns;
                    previousSpawnRate = DefaultSpawnRate;
                    DefaultMaxSpawns = 0;
                    DefaultSpawnRate = 0;
                    for (int i = 0; i < Main.npc.Length; i++)
                    {
                        if (Main.npc[i] != null && !Main.npc[i].townNPC)
                        {
                            Main.npc[i].life = 0;
                            if (Main.netMode == 2)
                            {
                                NetMessage.SendData(23, -1, -1, "", i, 0f, 0f, 0f, 0);
                            }
                        }
                    }
                    Main.NewText("Enemy Spawns Off", purple.R, purple.G, purple.B, false);
                }
                else
                {
                    DefaultMaxSpawns = previousMaxSpawns;
                    DefaultSpawnRate = previousSpawnRate;
                    Main.NewText("Enemy Spawns On", purple.R, purple.G, purple.B, false);
                }
            }
            else
                fresh = true;
        }
    }
}
