﻿using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;
using PluginLoader;
using Terraria;
using Terraria.ID;

namespace TranscendPlugins
{
    public class Teleport : MarshalByRefObject, IPluginPlayerUpdate
    {
        private int planteraBulbTileLookup;
        private Keys planteraKey;
        public Teleport()
        {
            var mapHelper = typeof(Terraria.Map.WorldMap).Assembly.GetType("Terraria.Map.MapHelper");
            var tileToLookup = mapHelper.GetMethod("TileToLookup");
            planteraBulbTileLookup = (int)tileToLookup.Invoke(null, new object[] { TileID.PlanteraBulb, 0 });

            if (!Keys.TryParse(IniAPI.ReadIni("Teleport", "PlanteraKey", "P", writeIt: true), out planteraKey))
                planteraKey = Keys.P;
        }

        public void OnPlayerUpdate()
        {
            if (Main.mapFullscreen && Main.keyState.IsKeyDown(planteraKey))
            {
                if (Main.Map == null) return;
                
                for (int i = 0; i < Main.Map.MaxWidth; i++)
                {
                    for (int j = 0; j < Main.Map.MaxHeight; j++)
                    {
                        if (Main.Map[i, j].Type == planteraBulbTileLookup)
                        {
                            Player player = Main.player[Main.myPlayer];
                            player.position = new Vector2(i * 16, j * 16);
                            player.velocity = Vector2.Zero;
                            player.fallStart = (int)(player.position.Y / 16f);
                            return;
                        }
                    }
                }
            }

            if (Main.mapFullscreen && Main.mouseRight && Main.keyState.IsKeyUp(Keys.LeftControl))
            {
                int num = Main.maxTilesX * 16;
                int num2 = Main.maxTilesY * 16;
                Vector2 vector = new Vector2((float)Main.mouseX, (float)Main.mouseY);
                vector.X -= (float)(Main.screenWidth / 2);
                vector.Y -= (float)(Main.screenHeight / 2);
                Vector2 mapFullscreenPos = Main.mapFullscreenPos;
                Vector2 vector2 = mapFullscreenPos;
                vector /= 16f;
                vector *= 16f / Main.mapFullscreenScale;
                vector2 += vector;
                vector2 *= 16f;
                Player player = Main.player[Main.myPlayer];
                vector2.Y -= (float)player.height;
                if (vector2.X < 0f)
                {
                    vector2.X = 0f;
                }
                else if (vector2.X + (float)player.width > (float)num)
                {
                    vector2.X = (float)(num - player.width);
                }
                if (vector2.Y < 0f)
                {
                    vector2.Y = 0f;
                }
                else if (vector2.Y + (float)player.height > (float)num2)
                {
                    vector2.Y = (float)(num2 - player.height);
                }
                player.position = vector2;
                player.velocity = Vector2.Zero;
                player.fallStart = (int)(player.position.Y / 16f);
            }
        }
    }
}
