﻿using System;
using Microsoft.Xna.Framework.Input;
using PluginLoader;
using Terraria;

namespace TranscendPlugins
{
    public class Time : MarshalByRefObject, IPluginPlayerUpdate
    {
        private Keys nightKey;
        private Keys dayKey;
        public Time()
        {
            if (!Keys.TryParse(IniAPI.ReadIni("Time", "Night", "OemComma", writeIt: true), out nightKey))
                nightKey = Keys.OemComma;
            if (!Keys.TryParse(IniAPI.ReadIni("Time", "Day", "OemPeriod", writeIt: true), out dayKey))
                dayKey = Keys.OemPeriod;
        }

        public void OnPlayerUpdate()
        {
            if (Main.keyState.IsKeyDown(nightKey))
            {
                Main.dayTime = false;
                Main.time = 27000.0;
            }
            else if (Main.keyState.IsKeyDown(dayKey))
            {
                Main.dayTime = true;
                Main.time = 27000.0;
            }
        }
    }
}
